function getParameter(l_sName)
{
	var l_oMatch = window.location.search.match(new RegExp("[?&]" + l_sName + "=([^&]*)"));
	return ((l_oMatch == null) ? null : l_oMatch[1]);
};

function trade(){
	console.log("trading");
	
	var currency1 = document.getElementById("currency1").value;
	var currency2 = document.getElementById("currency2").value;
	var amount = document.getElementById("amount").value;

	var fieldData = {
			"State":"Initial",
			"MsgType":"Open", 
			"RequestID":Math.floor(Math.random()*1000001+1000000), 
			"eventSource":"client",
			"ControlAddLeg":"1",
			"TradingProtocol":"ESP",

			"AssetClass":"FX",
			 
			"DealtCurrency":currency1, 
			"TermCurrency":currency2, 
			"BaseCurrency":currency1, 
			"Account":"acct1", 
			"BuySell":"BUY", 
			"Instrument":"/FX/"+currency1+currency2,
			"Amount":amount,
			"Tenor":"SPOT",
			"SettlementDate":"20130221", 
			"Price":"1.54820" 
	};
	var subject = "/PRIVATE/TRADE/FX";
	streamLink.publishToSubject(subject, fieldData, {
		onCommandOk : function(subject) {
			console.log("Publish to " + subject + " succeeded.");
			document.getElementById('disp_traderesult').innerHTML = subject + ' trade: Open';
					window.setTimeout(function(){document.getElementById('disp_traderesult').innerHTML ='';},2000);

		},
		onCommandError : function(subject, error) {
			console.log("Publish to " + subject + " failed due to " + error.getError()+".");
		}
	});
}

function login(){
	forceReconnect = false;
	var username = document.getElementById("username").value;
	var password = document.getElementById("password").value
	console.log("logging in as [" + username + "/" + password + "]");
	
	var host = getParameter("host");
	var port = getParameter("port");
	
	if (host == null || host == undefined || host == "")
		host = "rttp://" + document.domain;

	if (port == null || port == undefined )
		port = location.port;
			
	var serverUrl = host + ":" + port;
	
	streamLink = caplin.streamlink.StreamLinkFactory.create({
		username : username,
		password : password,
		liberator_urls : serverUrl
	});
	
	// Define a connection listener.
	var connectionListener = {
		onConnectionStatusChange : 	function(connectionStatusEvent) {
			var connectionState = connectionStatusEvent.getConnectionState();
			console.log("StreamLink connection is now \"" + connectionState);
			document.getElementById('disp_connstatus').innerHTML = connectionState;
		},
		
	};
	
	var tradeSubscriptionListener = {

			onSubscriptionStatus : function(subscription, event) {
				console.log(subscription.getSubject() + " is now " + event.getStatus());
			},

			onSubscriptionError : function(subscription, event)	{
				console.log("Error: Subject " + subscription.getSubject() + " is " + event.getError());
			},

			onRecordUpdate : function(subscription, event) {
				console.log(event);
				if (event.getFields().MsgType) {
					document.getElementById('disp_traderesult').innerHTML = subscription.getSubject() + ' trade ' + event.getFields().MsgType;
					window.setTimeout(function(){document.getElementById('disp_traderesult').innerHTML ='';},2000);
				}
			}
		};
	
	// Register the connection listener and connect.
	streamLink.addConnectionListener(connectionListener);
	
	var subject = "/PRIVATE/TRADE/FX";
	streamLink.subscribe(subject, tradeSubscriptionListener);

	streamLink.connect();
};

function disconnect() {
	streamLink.disconnect();
};

function reconnect1() {
	console.log("Losing network connectivity...");
	streamLink.disconnect();
	window.setTimeout(function(){console.log("Regaining network connectivity..."); streamLink.connect()}, 10000);
};

function reconnect2() {
	console.log("Losing network connectivity...");
	streamLink.networkUnavailable();
	window.setTimeout(function(){console.log("Regaining network connectivity..."); streamLink.networkAvailable()}, 10000);
};

function subscribe(){
	var subject = document.getElementById("subject").value;
	console.log("subscribing to  [" + subject + "]");
	
	var recordSubscriptionListener = {

		onSubscriptionStatus : function(subscription, event) {
				console.log(subscription.getSubject() + " is now " + event.getStatus());
			},

			onSubscriptionError : function(subscription, event)	{
				console.log("Error: Subject " + subscription.getSubject() + " is " + event.getError());
			},

			onRecordUpdate : function(subscription, event) {
				console.log("Update for [" + subscription.getSubject() + "]")
				console.info(event);
				document.getElementById('disp_subject').innerHTML = subscription.getSubject();
				document.getElementById('disp_bidprice').innerHTML = event.getFields().BidPrice;
				document.getElementById('disp_askprice').innerHTML = event.getFields().AskPrice;
			}
		};
	
	streamLink.subscribe(subject, recordSubscriptionListener);
}


